package i18n_context_bug
import "core:fmt"
import "core:path/filepath"
import "core:os"
import "core:strings"
import "core:text/i18n"

main :: proc()
{
	// build the path of a message catalogue parallel to the executable
	app_path:	= os.args[0]
	cat_path:	= strings.join({filepath.dir(app_path), "no_context.mo"}, "/")
	defer delete(cat_path)

	// parse and load the message catalogue without contexts:
	// THIS WORKS
	i18n_err:	i18n.Error
	i18n.ACTIVE, i18n_err	= i18n.parse_mo_file(cat_path)
	if (i18n_err == i18n.Error.None || i18n_err == nil)
	{
		defer i18n.destroy(i18n.ACTIVE)
		// The "Message1" is translate as "This is messge 1"
		fmt.println(i18n.get("Message1"))
	}
	else	do fmt.println("Error parsing no context message catalogue:", i18n_err)

	// parse and load the message catalogue WITH contexts:
	// THIS DOES NOT WORK
	cat_path	= strings.join({filepath.dir(app_path), "context.mo"}, "/")
	defer delete(cat_path)
	i18n.ACTIVE, i18n_err	= i18n.parse_mo_file(cat_path)
	if (i18n_err == i18n.Error.None || i18n_err == nil)
	{
		defer i18n.destroy(i18n.ACTIVE)
		// The "Message1" is translate as "This is messge 1" under a context of "Context":
		// the translation is not found and the key returned as translation
		fmt.println(i18n.get("Message1"))
	}
	else	do fmt.println("Error parsing context message catalogue:", i18n_err)
}